const Docker = require("dockerode");
const docker = new Docker();
const stream = require("stream");

const logs = (ws, container) => {
  var logStream = new stream.PassThrough();
  logStream.on("data", function (chunk) {
    ws.send({
      method: "logs",
      event: "log",
      container: container.id,
      output: chunk.toString("utf8"),
    });
  });
  container = docker.getContainer(container);
  container.logs(
    {
      follow: true,
      stdout: true,
      stderr: true,
    },
    function (err, stream) {
      if (err) {
        return console.error(err.message);
      }
      container.modem.demuxStream(stream, logStream, logStream);
    }
  );
};

module.exports = logs;
