const Docker = require("dockerode");
const docker = new Docker();

const pull = async (ws, image) => {
  if (
    !image.startsWith("nyxteam/oyunparki-small") &&
    !image.startsWith("nyxteam/oyunparki-full")
  ) {
    ws.send({
      method: "pull",
      event: "done",
      output: "wrong image",
    });
    return;
  }
  await docker.pull(image, function (err, stream) {
    const onFinished = (err, output) => {
      ws.send({ method: "pull", event: "done", output: output });
    };

    const onProgress = (event) => {
      ws.send({
        method: "pull",
        event: "progress",
        output: JSON.stringify(event),
      });
    };
    docker.modem.followProgress(stream, onFinished, onProgress);
  });
};

module.exports = pull;
