const Docker = require("dockerode");
const docker = new Docker();

// Değerli Türk Bilim Insanlarının isimleri parklarımıza ithaf edildi.
// https://tr.wikipedia.org/wiki/T%C3%BCrk_bilim_insanlar%C4%B1_listesi

const names = {
  "Ahmet Cevdet Paşa": "Ahmet-Cevdet-Pasa",
  "Ahmed Resmî Efendi": "Ahmed-Resm-Efendi",
  "Abbas Vesim Efendi": "Abbas-Vesim-Efendi",
  "Ahmed Cemal Eringen": "Ahmed-Cemal-Eringen",
  "Ahmet S. Çakmak": "Ahmet-S-Cakmak",
  "Ahmet Ziyaeddin Akçasu": "Ahmet-Ziyaeddin-Akcasu",
  Akşemseddin: "Aksemseddin",
  "Ali Akansu": "Ali-Akansu",
  "Ali Erdemir": "Ali-Erdemir",
  "Ali Demirsoy": "Ali-Demirsoy",
  "Ali Kuşçu": "Ali-Kuscu",
  "Ali Nesin": "Ali-Nesin",
  "Asım Orhan Barut": "Asim-Orhan-Barut",
  "Ataç İmamoğlu": "Atac-Imamoglu",
  "Attila Aşkar": "Attila-Askar",
  "Asuman Baytop": "Asuman-Baytop",
  "Asuman Özdağlar": "Asuman-Ozdaglar",
  "Aydın Sayılı": "Aydin-Sayili",
  "Aykut Barka": "Aykut-Barka",
  "Aykut Kence": "Aykut-Kence",
  "Aziz Sancar": "Aziz-Sancar",
  "Bahattin Baysal": "Bahattin-Baysal",
  "Behram Kurşunoğlu": "Behram-Kursunoglu",
  "Betül Kaçar": "Betul-Kacar",
  "Bilge Demirköz": "Bilge-Demirkoz",
  "Bursalı Kadızade Rumi": "Bursali-Kadizade-Rumi",
  "Cahit Arf": "Cahit-Arf",
  "Canan Dağdeviren": "Canan-Dagdeviren",
  "Cavid Erginsoy": "Cavid-Erginsoy",
  "Celâl Şengör": "Cell-Sengor",
  "Daron Acemoğlu": "Daron-Acemoglu",
  "Dilhan Eryurt": "Dilhan-Eryurt",
  "Derya Akkaynak": "Derya-Akkaynak",
  "Ekrem Akurgal": "Ekrem-Akurgal",
  "Erdal İnönü": "Erdal-Inonu",
  "Ergi Deniz Özsoy": "Ergi-Deniz-Ozsoy",
  "Erhan Çınlar": "Erhan-Cinlar",
  "Erzurumlu İbrahim Hakkı": "Erzurumlu-Ibrahim-Hakki",
  "Engin Arık": "Engin-Arik",
  Farabi: "Farabi",
  "Fazıl Erdoğan": "Fazil-Erdogan",
  Fergani: "Fergani",
  "Feza Gürsey": "Feza-Gursey",
  "Feryal Özel": "Feryal-Ozel",
  "Galip Ulsoy": "Galip-Ulsoy",
  "Gazi Yaşargil": "Gazi-Yasargil",
  "Gelenbevi İsmail Efendi": "Gelenbevi-Ismail-Efendi",
  "Halil İnalcık": "Halil-Inalcik",
  "Hezârfen Ahmed Çelebi": "Hezrfen-Ahmed-Celebi",
  "Hulusi Behçet": "Hulusi-Behcet",
  "Hüseyin Yılmaz": "Huseyin-Yilmaz",
  "İbn Türk": "Ibn-Turk",
  "İhsan Ketin": "Ihsan-Ketin",
  "İlber Ortaylı": "Ilber-Ortayli",
  "İlhan Aksay": "Ilhan-Aksay",
  "Janet Akyüz Mattei": "Janet-Akyuz-Mattei",
  "Kâşgarlı Mahmud": "Ksgarli-Mahmud",
  "Kâtip Çelebi": "Ktip-Celebi",
  "Kemal Reis": "Kemal-Reis",
  "Lagarî Hasan Çelebi": "Lagar-Hasan-Celebi",
  "Masatoşi Gündüz İkeda": "Masatosi-Gunduz-Ikeda",
  "Mehmet Fuad Köprülü": "Mehmet-Fuad-Koprulu",
  "Mehmet Özgür Oktel": "Mehmet-Ozgur-Oktel",
  "Metin Gürses": "Metin-Gurses",
  "Mete Atatüre": "Mete-Atature",
  "Mirim Çelebi": "Mirim-Celebi",
  "Merkez Efendi": "Merkez-Efendi",
  "Mustafa İnan": "Mustafa-Inan",
  "Muzafer Sherif": "Muzafer-Sherif",
  "Müneccimbaşı Ahmed Dede": "Muneccimbasi-Ahmed-Dede",
  "Nihat Berker": "Nihat-Berker",
  "Okan K. Ersoy": "Okan-K-Ersoy",
  "Oktay Sinanoğlu": "Oktay-Sinanoglu",
  "Ongun Alsaç": "Ongun-Alsac",
  "Piri Reis": "Piri-Reis",
  "Ratip Berker": "Ratip-Berker",
  "Reşit Süreyya Gürsey": "Resit-Sureyya-Gursey",
  "Selman Akbulut": "Selman-Akbulut",
  "Seydi Ali Reis": "Seydi-Ali-Reis",
  "Sırrı Erinç": "Sirri-Erinc",
  "Sinan Keten": "Sinan-Keten",
  "Suha Gürsey": "Suha-Gursey",
  "Sabuncuoğlu Şerefeddin": "Sabuncuoglu-Serefeddin",
  Takiyüddin: "Takiyuddin",
  "Tamer Başar": "Tamer-Basar",
  "Turhan Baytop": "Turhan-Baytop",
  "Uğur Şahin": "Ugur-Sahin",
  "Uluğ Bey": "Ulug-Bey",
  "Umran İnan": "Umran-Inan",
  "Vamık Volkan": "Vamik-Volkan",
  "Yavuz Nutku": "Yavuz-Nutku",
};

const generate = () => {
  return new Promise((resolve, reject) => {
    docker
      .listContainers({ all: true })
      .then((cnt) => {
        const containers = cnt.map((c) => {
          return c.Names[0].substring(1);
        });
        _names = Object.values(names).filter(
          (n) =>
            !containers.some((c) => {
              return c.startsWith(n);
            })
        );
        resolve(_names[Math.floor(Math.random() * _names.length)]);
      })
      .catch(() => {
        reject();
      });
  });
};

const convert = (n) => {
  const name = n.replace(/^\/(.*)-Parki$/gm, "$1");
  return `${Object.keys(names).find((k) => names[k] === name)} Parkı`;
};

module.exports.generate = generate;
module.exports.convert = convert;
