const pull = require("../docker/controllers/pull");
const logs = require("../docker/controllers/logs");

const handler = (ws, _) => {
  ws = {
    handler: ws,
    send: function (msg) {
      try {
        if (this.handler.readyState === this.handler.OPEN)
          this.handler.send(
            typeof msg === "object" ? JSON.stringify(msg) : msg
          );
      } catch (e) {
        console.log(e);
      }
    },
  };
  ws.handler.on("message", (m) => {
    try {
      m = JSON.parse(m);
      m.method === "pull" && pull(ws, m.image);
      m.method === "logs" && logs(ws, m.container);
    } catch (e) {}
  });
};

module.exports = (app) => {
  app.ws("/socket/", handler);
  app.ws("/socket/.*/", handler);
};
